//
// DungeonQuest Combat Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-combat-front-sheet-template", "dungeonquest/templates/dq-combat-back.jp2",
	"dungeonquest-combat-back-sheet-template", "dungeonquest/templates/dq-combat-back.jp2",

	"dungeonquest-combat-portrait-template", "dungeonquest/portraits/image_1.jpg",
	"dungeonquest-combat-portrait-clip-region", "0,136,244,240",
	"dungeonquest-combat-portrait-scale", ".6",
	"dungeonquest-combat-portrait-panx", "0",
	"dungeonquest-combat-portrait-pany", "0",

	"dungeonquest-combat-title-region", "32,102,181,22",
	"dungeonquest-combat-portrait-clip-region-large", "0,136,244,240",
	"dungeonquest-combat-portrait-clip-region-small", "0,295,244,81",	
	"dungeonquest-combat-text-region", "17,150,210,135"
	
)

var rangedTop = Image.fetchImageResource( "dungeonquest/templates/dq-combat-top-ranged.jp2", true );
var magicTop = Image.fetchImageResource( "dungeonquest/templates/dq-combat-top-magic.jp2", true );
var meleeTop = Image.fetchImageResource( "dungeonquest/templates/dq-combat-top-melee.jp2", true );
var rangedBasic = Image.fetchImageResource( "dungeonquest/templates/dq-combat-basic-ranged.jp2", true );
var magicBasic = Image.fetchImageResource( "dungeonquest/templates/dq-combat-basic-magic.jp2", true );
var meleeBasic = Image.fetchImageResource( "dungeonquest/templates/dq-combat-basic-melee.jp2", true );
var rangedBody = Image.fetchImageResource( "dungeonquest/templates/dq-combat-body-ranged.jp2", true );
var magicBody = Image.fetchImageResource( "dungeonquest/templates/dq-combat-body-magic.jp2", true );
var meleeBody = Image.fetchImageResource( "dungeonquest/templates/dq-combat-body-melee.jp2", true );
var rangedTitle = Image.fetchImageResource( "dungeonquest/templates/dq-combat-title-ranged.jp2", true );
var magicTitle = Image.fetchImageResource( "dungeonquest/templates/dq-combat-title-magic.jp2", true );
var meleeTitle = Image.fetchImageResource( "dungeonquest/templates/dq-combat-title-melee.jp2", true );
var heroEscape = Image.fetchImageResource( "dungeonquest/templates/dq-combat-escape-hero.jp2", true );
var monsterEscape = Image.fetchImageResource( "dungeonquest/templates/dq-combat-escape-monster.jp2", true );
var noCounter = Image.fetchImageResource( "dungeonquest/templates/dq-combat-no-counter.jp2", true );
var pictureBorder = Image.fetchImageResource( "dungeonquest/templates/dq-combat-picture-border.jp2", true );

var cb00 = Image.fetchImageResource( "dungeonquest/elements/cb00.png", true );
var cb01 = Image.fetchImageResource( "dungeonquest/elements/cb01.png", true );
var cb02 = Image.fetchImageResource( "dungeonquest/elements/cb02.png", true );
var cb03 = Image.fetchImageResource( "dungeonquest/elements/cb03.png", true );
var cb04 = Image.fetchImageResource( "dungeonquest/elements/cb04.png", true );
var cb05 = Image.fetchImageResource( "dungeonquest/elements/cb05.png", true );
var cb06 = Image.fetchImageResource( "dungeonquest/elements/cb06.png", true );
var cr00 = Image.fetchImageResource( "dungeonquest/elements/cr00.png", true );
var cr01 = Image.fetchImageResource( "dungeonquest/elements/cr01.png", true );
var cr02 = Image.fetchImageResource( "dungeonquest/elements/cr02.png", true );
var cr03 = Image.fetchImageResource( "dungeonquest/elements/cr03.png", true );
var cr04 = Image.fetchImageResource( "dungeonquest/elements/cr04.png", true );
var cr05 = Image.fetchImageResource( "dungeonquest/elements/cr05.png", true );
var cr06 = Image.fetchImageResource( "dungeonquest/elements/cr06.png", true );
var cy00 = Image.fetchImageResource( "dungeonquest/elements/cy00.png", true );
var cy01 = Image.fetchImageResource( "dungeonquest/elements/cy01.png", true );
var cy02 = Image.fetchImageResource( "dungeonquest/elements/cy02.png", true );
var cy03 = Image.fetchImageResource( "dungeonquest/elements/cy03.png", true );
var cy04 = Image.fetchImageResource( "dungeonquest/elements/cy04.png", true );
var cy05 = Image.fetchImageResource( "dungeonquest/elements/cy05.png", true );
var cy06 = Image.fetchImageResource( "dungeonquest/elements/cy06.png", true );
var cw00 = Image.fetchImageResource( "dungeonquest/elements/cw00.png", true );
var cw01 = Image.fetchImageResource( "dungeonquest/elements/cw01.png", true );
var cw02 = Image.fetchImageResource( "dungeonquest/elements/cw02.png", true );
var cw03 = Image.fetchImageResource( "dungeonquest/elements/cw03.png", true );
var cw04 = Image.fetchImageResource( "dungeonquest/elements/cw04.png", true );
var cw05 = Image.fetchImageResource( "dungeonquest/elements/cw05.png", true );
var cw06 = Image.fetchImageResource( "dungeonquest/elements/cw06.png", true );
var db00 = Image.fetchImageResource( "dungeonquest/elements/db00.png", true );
var db01 = Image.fetchImageResource( "dungeonquest/elements/db01.png", true );
var db02 = Image.fetchImageResource( "dungeonquest/elements/db02.png", true );
var db03 = Image.fetchImageResource( "dungeonquest/elements/db03.png", true );
var db04 = Image.fetchImageResource( "dungeonquest/elements/db04.png", true );
var db05 = Image.fetchImageResource( "dungeonquest/elements/db05.png", true );
var db06 = Image.fetchImageResource( "dungeonquest/elements/db06.png", true );

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.PLAIN_BACK;
	diy.frontTemplateKey = "dungeonquest-combat-front-sheet";
	diy.backTemplateKey = "dungeonquest-combat-back-sheet";
	diy.portraitKey = "dungeonquest-combat";

	diy.name = "<+ H>ammer <+ T>ime";
	diy.comment = "Here we go again...";
	$SpecialText = "Some Effects.";
	$Front = "Basic";	 
	$Attack = "Melee";              
	$Type = "Monster"; 			
	$Counter = "None"; 
	$AValue = "4"; 
	$EValue = "3"; 
	$DValue = "2"; 
}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	
	
	var attr1Panel = new Grid();
	attr1Panel.place(
		"Attack", "", "Escape", "gap unrel", "Damage", "gap unrel, wrap"
	);	
	
	var attr1Keys = [ "AValue", "EValue", "DValue" ];
	for( var i=0; i<3; ++i ) {
		var attr1Combo = comboBox( [ "0", "1", "2", "3", "4", "5", "6" ] );
		attr1Panel.place( attr1Combo, "growx, width pref+20lp" + (i > 0 ? ",gap unrel" : "") );
		bindings.add( attr1Keys[i], attr1Combo, [0] );
	}	
	
	var frontCombo = comboBox( [	
		"Basic",
		"Effects"
	] );	
	
	var attackCombo = comboBox( [	
		"Ranged",
		"Magic",
		"Melee"
	] );
	
	var typeCombo = comboBox( [	
		"Hero",
		"Monster"
	] );

	var counterCombo = comboBox( [	
		"Standard",
		"None"
	] );	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Front", "split", frontCombo, "width pref+20lp, wrap",
		"Type", "split", typeCombo, "width pref+20lp, wrap",	
		"Attack", "split", attackCombo, "width pref+20lp, wrap",			
		"Counter", "split", counterCombo, "width pref+20lp, wrap",
		attr1Panel, "span, growx, wrap",	
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );
	bindings.add( "Front", frontCombo, [0] );	
	bindings.add( "Type", typeCombo, [0] );	
	bindings.add( "Attack", attackCombo, [0] );
	bindings.add( "Counter", counterCombo, [0] );		
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, typeBox, valueBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 8 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 8 );	
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_TOP|specialTextBox.LAYOUT_CENTER;

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		if( $Attack == "Ranged" ) {
			cardTop = rangedTop;
			cardBasic = rangedBasic;
			cardBody = rangedBody;
			cardTitle = rangedTitle;
			if( $AValue == "0" ) {
		        attackValue = cb00;
	        }
			else if( $AValue == "1" ) {
		        attackValue = cb01;
	        }
			else if( $AValue == "2" ) {
		        attackValue = cb02;
	        } 
			else if( $AValue == "3" ) {
		        attackValue = cb03;
    	    } 
			else if( $AValue == "4" ) {
		        attackValue = cb04;
    	    }
			else if( $AValue == "5" ) {
    		    attackValue = cb05;
    	    } 
			else if( $AValue == "6" ) {
 	      		attackValue = cb06;
			} 
        }
		else if( $Attack == "Magic" ) {
			cardTop = magicTop;
			cardBasic = magicBasic;
			cardBody = magicBody;
			cardTitle = magicTitle;
			if( $AValue == "0" ) {
		        attackValue = cy00;
	        }
			else if( $AValue == "1" ) {
		        attackValue = cy01;
	        }
			else if( $AValue == "2" ) {
		        attackValue = cy02;
	        } 
			else if( $AValue == "3" ) {
		        attackValue = cy03;
    	    } 
			else if( $AValue == "4" ) {
		        attackValue = cy04;
    	    }
			else if( $AValue == "5" ) {
    		    attackValue = cy05;
    	    } 
			else if( $AValue == "6" ) {
 	      		attackValue = cy06;
			} 
        }        
        else if( $Attack == "Melee" ) {
			cardTop = meleeTop;
			cardBasic = meleeBasic;
			cardBody = meleeBody;
			cardTitle = meleeTitle;
			if( $AValue == "0" ) {
		        attackValue = cr00;
	        } else if( $AValue == "1" ) {
		        attackValue = cr01;
	        }
			else if( $AValue == "2" ) {
		        attackValue = cr02;
	        } 
			else if( $AValue == "3" ) {
		        attackValue = cr03;
    	    } 
			else if( $AValue == "4" ) {
		        attackValue = cr04;
    	    }
			else if( $AValue == "5" ) {
    		    attackValue = cr05;
    	    } 
			else if( $AValue == "6" ) {
 	      		attackValue = cr06;
			} 
        }	
        
		if( $EValue == "0" ) {
        escapeValue = cw00;
        }
		else if( $EValue == "1" ) {
        escapeValue = cw01;
        }
		else if( $EValue == "2" ) {
        escapeValue = cw02;
        } 
		else if( $EValue == "3" ) {
        escapeValue = cw03;
        } 
		else if( $EValue == "4" ) {
        escapeValue = cw04;
        }
		else if( $EValue == "5" ) {
        escapeValue = cw05;
        } 
		else if( $EValue == "6" ) {
        escapeValue = cw06;
        }   

		if( $DValue == "0" ) {
        damageValue = db00;
        }
		else if( $DValue == "1" ) {
        damageValue = db01;
        }
		else if( $DValue == "2" ) {
        damageValue = db02;
        } 
		else if( $DValue == "3" ) {
        damageValue = db03;
        } 
		else if( $DValue == "4" ) {
        damageValue = db04;
        }
		else if( $DValue == "5" ) {
        damageValue = db05;
        } 
		else if( $DValue == "6" ) {
        damageValue = db06;
        }         	        
		
		if( $Front == "Basic" ) {
			$dungeonquest_combat_portrait_clip_region = $dungeonquest_combat_portrait_clip_region_large;
		} else {
			$dungeonquest_combat_portrait_clip_region = $dungeonquest_combat_portrait_clip_region_small;
		}			

		if( $Front == "Basic" ) {		
			sheet.paintPortrait( g );
			g.drawImage( cardBasic, 0, 133, null );		
		} else {
			g.drawImage( cardBody, 0, 135, null );	
			sheet.paintPortrait( g );
			g.drawImage( pictureBorder, 0, 287, null );	
		}	

		g.drawImage( cardTitle, 0, 0, null );
			
		if( $Counter == "None" ) {		
			g.drawImage( noCounter, 131, 20, null );		
		}	
			
		g.drawImage( cardTop, 0, 0, null );	

		g.setPaint( Color.BLACK );				
		
		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-combat-title") );		

		if( $Front != "Basic" ) {		
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-combat-text") );	
		}
		
		g.drawImage( attackValue, 12.5, 22, 55, 55, null );
		
		if( $Type == "Hero" ) {
			g.drawImage( heroEscape, 0, 288, null );
			g.drawImage( escapeValue, 10, 302, 60, 60, null );
		} else {
			g.drawImage( monsterEscape, 0, 288, null );
			g.drawImage( escapeValue, 7, 312, 40, 40, null );
			g.drawImage( damageValue, 37, 312, 40, 40, null );		
		}		
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {}
function paintBack( g, c, s ) {}

function onClear( diy ) {
	$SpecialText = "";
}

function onRead() {}
function onWrite() {}

// testDIYScript();