//
// DungeonQuest Dragon Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-dragon-front-sheet-template", "dungeonquest/templates/dq-dragon-front.jp2",
	"dungeonquest-dragon-back-sheet-template", "dungeonquest/templates/dq-dragon-back.jp2",

	"dungeonquest-dragon-portrait-template", "dungeonquest/portraits/image_1.jpg",
	"dungeonquest-dragon-portrait-clip-region", "0,69,244,120",
	"dungeonquest-dragon-portrait-scale", ".58",
	"dungeonquest-dragon-portrait-panx", "0",
	"dungeonquest-dragon-portrait-pany", "25",

	"dungeonquest-dragon-title-region", "30,26,182,22",	
	"dungeonquest-dragon-text-region", "17,213,210,147"
	
)

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.PLAIN_BACK;
	diy.frontTemplateKey = "dungeonquest-dragon-front-sheet";
	diy.backTemplateKey = "dungeonquest-dragon-back-sheet";
	diy.portraitKey = "dungeonquest-dragon";

	diy.name = "<+ N>ot <+ H>ere";
	diy.comment = "Here we go again...";
	$SpecialText = "Oh dear. It's that Ogre again...";		

}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );	
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, typeBox, valueBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 8 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 8 );	
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_TOP|specialTextBox.LAYOUT_CENTER;	

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		sheet.paintPortrait( g );

		g.setPaint( Color.BLACK );	
		
		sheet.paintTemplateImage( g );

		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-dragon-title") );
		
		specialTextBox.markupText = MACROS + $SpecialText;
		specialTextBox.draw( g, settings.getRegion("dungeonquest-dragon-text") );			
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {}
function paintBack( g, c, s ) {}

function onClear( diy ) {
	$SpecialText = "";
}

function onRead() {}
function onWrite() {}

// testDIYScript();