//
// DungeonQuest Explore Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-explore-front-sheet-template", "dungeonquest/templates/dq-explore-front-1.jp2",
	"dungeonquest-explore-back-sheet-template", "dungeonquest/templates/dq-treasure-back.jp2",

	"dungeonquest-explore-portrait-template", "dungeonquest/portraits/image_1.jpg",
	"dungeonquest-explore-portrait-clip-region", "0,78,244,162",
	"dungeonquest-explore-portrait-scale", ".574",
	"dungeonquest-explore-portrait-panx", "0",
	"dungeonquest-explore-portrait-pany", "22",

	"dungeonquest-explore-portrait-clip-region-large", "0,78,244,162",
	"dungeonquest-explore-portrait-clip-region-small", "0,84,244,105",
	"dungeonquest-explore-title-region", "32,33,181,22",
	"dungeonquest-explore-type-region", "32,48,181,20",
//	"dungeonquest-explore-value-region", "50,263,146,60",
//	"dungeonquest-explore-value-small-region", "77,309,92,50",	
	"dungeonquest-explore-text-micro-region", "17,263,210,55",
	"dungeonquest-explore-text-mini-region", "17,213,210,105",
	"dungeonquest-explore-text-midi-region", "17,213,210,150",
	"dungeonquest-explore-text-maxi-region", "17,92,210,225"
)

var exploreFront1 = Image.fetchImageResource( "dungeonquest/templates/dq-explore-front-1.jp2", true );
var exploreFront2 = Image.fetchImageResource( "dungeonquest/templates/dq-explore-front-2.jp2", true );
var exploreFront3 = Image.fetchImageResource( "dungeonquest/templates/dq-explore-front-3.jp2", true );
var exploreFront4 = Image.fetchImageResource( "dungeonquest/templates/dq-explore-front-4.jp2", true );

var catacombBack = Image.fetchImageResource( "dungeonquest/templates/dq-catacomb-back.jp2", true );
var corpseOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-corpse-back.jp2", true );
var cryptOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-crypt-back.jp2", true );
var doorOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-door-back.jp2", true );
var dungeonOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-dungeon-back.jp2", true );
var searchOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-search-back.jp2", true );
var trapOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-trap-back.jp2", true );
//var treasureBack = Image.fetchImageResource( "dungeonquest/templates/dq-treasure-back.jp2", true );

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.TWO_FACES;
	diy.frontTemplateKey = "dungeonquest-explore-front-sheet";
	diy.backTemplateKey = "dungeonquest-explore-back-sheet";
	diy.portraitKey = "dungeonquest-explore";

	diy.name = "<+ H>ammer <+ O>gre";
	diy.comment = "Here we go again...";
	$SpecialText = "Roll 1 die and add 2 to the "
	               + "result to determine how many "
	               + "wounds the Ogre inflicts."
	$Front = "Micro";	               
	$Back = "Dungeon";	 
	$Type = "Threat";              
//	$Value = "2,000";			

}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	
	
	var frontCombo = comboBox( [	
		"Micro",
		"Mini",	
		"Midi",	
		"Maxi"
	] );	
	
	var backCombo = comboBox( [	
		"Catacomb",
		"Corpse",		
		"Crypt",
		"Door",
		"Dungeon",
		"Search",
		"Trap"
//		"Treasure"
	] );	
	
	var typeCombo = comboBox( [	
		"Event",
//		"Loot",	
		"Monster",	
		"Threat",
		"Trap"
	] );
	
//	var valueCombo = autocompletionField( [	
//		"0",
//		"1",		
//		"10",
//		"100",
//		"1,000"
//	] );	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Text Box", "split", frontCombo, "width pref+20lp, wrap",		
		"Back", "split", backCombo, "width pref+20lp, wrap",
		"Type", "split", typeCombo, "width pref+20lp, wrap",			
//		"Value", "split", valueCombo, "width pref+20lp, wrap",	
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );
	bindings.add( "Front", frontCombo, [0] );	
	bindings.add( "Back", backCombo, [1] );	
	bindings.add( "Type", typeCombo, [0] );	
//	bindings.add( "Value", valueCombo, [0] );		
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, typeBox, valueBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 8 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 8.5 );	
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_TOP|specialTextBox.LAYOUT_CENTER;
	typeBox = createTitleBox( sheet, false, 7 );	
//	valueBox = createNumberBox( sheet );
//  valueBox.defaultStyle.add( SIZE, 25 );
//	valuesmallBox = createNumberBox( sheet );
//  valuesmallBox.defaultStyle.add( SIZE, 15 );		

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		if( $Front == "Micro" ) {
			$dungeonquest_explore_portrait_clip_region = $dungeonquest_explore_portrait_clip_region_large;
		} else {
			$dungeonquest_explore_portrait_clip_region = $dungeonquest_explore_portrait_clip_region_small;
		}		
		
		sheet.paintPortrait( g );

		g.setPaint( Color.BLACK );	

		if( $Front == "Micro" ) {		
			g.drawImage( exploreFront1, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-explore-text-micro") );	    
        } else if( $Front == "Mini" ) {
			g.drawImage( exploreFront2, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-explore-text-mini") );
		} else if( $Front == "Midi" ) {
			g.drawImage( exploreFront3, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-explore-text-midi") );
		} else if( $Front == "Maxi" ) {
			g.drawImage( exploreFront4, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-explore-text-maxi") );
		}
		
//		sheet.paintTemplateImage( g );

//		titleBox.markupText = "<b>" + diy.name + "</b>";
		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-explore-title") );
		
		typeBox.markupText = "<i>" + $Type + "</i>";
		typeBox.draw( g, settings.getRegion("dungeonquest-explore-type") );
		
//		specialTextBox.markupText = MACROS + $SpecialText;
//		specialTextBox.draw( g, settings.getRegion("dungeonquest-explore-text") );			
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {
}
function paintBack( g, diy, sheet ) {	

		try {
		var settings = diy.settings;
		
		if( $Back == "Catacomb" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 
        }
		else if( $Back == "Corpse" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( corpseOverlay, 31, 97, null ); 	
        }        
        else if( $Back == "Crypt" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( cryptOverlay, 31, 97, null ); 		  	
        }
		else if( $Back == "Door" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( doorOverlay, 31, 97, null ); 	
        }    
		else if( $Back == "Dungeon" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( dungeonOverlay, 31, 97, null ); 	
        }        
        else if( $Back== "Search" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( searchOverlay, 31, 97, null ); 		  	
        } 
		else if( $Back == "Trap" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( trapOverlay, 31, 97, null ); 	
        }     
//      else if( $Back== "Treasure" ) {
//	    g.drawImage( treasureBack, 0, 0, null );		
//      } 	
   
	    } catch( ex ) { error.handleUncaught( ex ); }
}

function onClear( diy ) {
	$SpecialText = "";
	$Life = "1";		
	$Strength = "1";
	$Agility = "1";
	$Armor = "1";
	$Luck = "1";
}

function onRead() {}
function onWrite() {}

// testDIYScript();