//
// DungeonQuest Rune Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-rune-front-sheet-template", "dungeonquest/templates/dq-rune-front.jp2",
	"dungeonquest-rune-back-sheet-template", "dungeonquest/templates/dq-rune-back.jp2",

	"dungeonquest-rune-portrait-template", "dungeonquest/portraits/rune_of_hazards.jpg",
	"dungeonquest-rune-portrait-clip-region", "60,102,122,122",
	"dungeonquest-rune-portrait-scale", "0.28",
	"dungeonquest-rune-portrait-panx", "0",
	"dungeonquest-rune-portrait-pany", "0",

	"dungeonquest-rune-title-region", "32,33,181,22",
	"dungeonquest-rune-text-region", "27,249,190,100"
)

var runeFrontOrange = Image.fetchImageResource( "dungeonquest/templates/dq-rune-front.jp2", true );
var runeFrontGreen = Image.fetchImageResource( "dungeonquest/templates/dq-rune-front-green.jp2", true );
var runeFrontBlue = Image.fetchImageResource( "dungeonquest/templates/dq-rune-front-blue.jp2", true );
var runeFrontYellow = Image.fetchImageResource( "dungeonquest/templates/dq-rune-front-yellow.jp2", true );

var runeBaseOrange = Image.fetchImageResource( "dungeonquest/templates/dq-rune-base.jp2", true );
var runeBaseGreen = Image.fetchImageResource( "dungeonquest/templates/dq-rune-base-green.jp2", true );
var runeBaseBlue = Image.fetchImageResource( "dungeonquest/templates/dq-rune-base-blue.jp2", true );
var runeBaseYellow = Image.fetchImageResource( "dungeonquest/templates/dq-rune-base-yellow.jp2", true );

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.PLAIN_BACK;
	diy.frontTemplateKey = "dungeonquest-rune-front-sheet";
	diy.backTemplateKey = "dungeonquest-rune-back-sheet";
	diy.portraitKey = "dungeonquest-rune";

	diy.name = "<+ R>une of <+ H>azards";
	diy.comment = "Here we go again...";
	$Glow = "Orange";		
	$SpecialText = "Discard when you draw a "
	               + "<i><b>Trap</b></i> card or tile to "
	               + "discard that card/tile and draw again."		

}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	

	var glowCombo = comboBox( [	
		"Blue",		
		"Green",
		"Orange",		
		"Yellow"
	] );	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Glow", "split", glowCombo, "width pref+20lp, wrap",		
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );	
	bindings.add( "Glow", glowCombo, [0] );		
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, typeBox, valueBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 8 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 8.5 );	
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_MIDDLE|specialTextBox.LAYOUT_CENTER;		

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		if( $Glow == "Blue" ) {
	    runeFront = runeFrontBlue;    
	    runeBase = runeBaseBlue;    
        }
        else if( $Glow == "Green" ) {
	    runeFront = runeFrontGreen;    
	    runeBase = runeBaseGreen;    
        }
		else if( $Glow == "Orange" ) {
	    runeFront = runeFrontOrange;    
	    runeBase = runeBaseOrange;    
        }     
        else if( $Glow == "Yellow" ) {
	    runeFront = runeFrontYellow;    
	    runeBase = runeBaseYellow;    
        }	

		g.drawImage( runeBase, 62, 105, null );	
		
		sheet.paintPortrait( g );
		
		g.drawImage( runeFront, 0, 0, null );	
		
//		sheet.paintTemplateImage( g );		

		g.setPaint( Color.BLACK );	

		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-rune-title") );
		
		specialTextBox.markupText = MACROS + $SpecialText;
		specialTextBox.draw( g, settings.getRegion("dungeonquest-rune-text") );			
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {}
function paintBack( g, c, s ) {}

function onClear( diy ) {
	$SpecialText = "";
}

function onRead() {}
function onWrite() {}

// testDIYScript();