//
// DungeonQuest Treasure Card Example
//

uselibrary( "ui" );
uselibrary( "diy" );
uselibrary( "markup" );
uselibrary( "imageutils" );
uselibrary( "res://dungeonquest/lib.js" );

Patch.temporary(
	"dungeonquest-treasure-front-sheet-template", "dungeonquest/templates/dq-treasure-front.jp2",
	"dungeonquest-treasure-back-sheet-template", "dungeonquest/templates/dq-treasure-back.jp2",

	"dungeonquest-treasure-portrait-template", "dungeonquest/portraits/image_1.jpg",
	"dungeonquest-treasure-portrait-clip-region", "0,69,244,138",
	"dungeonquest-treasure-portrait-scale", ".85",
	"dungeonquest-treasure-portrait-panx", "40",
	"dungeonquest-treasure-portrait-pany", "72",

	"dungeonquest-treasure-title-region", "32,29,181,22",
	"dungeonquest-treasure-type-region", "32,44,181,20",
	"dungeonquest-treasure-value-region", "50,263,146,60",
	"dungeonquest-treasure-value-small-region", "77,309,92,50",	
	"dungeonquest-treasure-text-region", "17,213,210,147",
	"dungeonquest-treasure-text-small-region", "17,213,210,62"
	
)

var treasureFront = Image.fetchImageResource( "dungeonquest/templates/dq-treasure-front.jp2", true );
var treasurespecialFront = Image.fetchImageResource( "dungeonquest/templates/dq-treasure-front-special.jp2", true );
var treasuretextFront = Image.fetchImageResource( "dungeonquest/templates/dq-treasure-front-text.jp2", true );

var catacombBack = Image.fetchImageResource( "dungeonquest/templates/dq-catacomb-back.jp2", true );
var corpseOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-corpse-back.jp2", true );
var cryptOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-crypt-back.jp2", true );
//var doorOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-door-back.jp2", true );
var dungeonOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-dungeon-back.jp2", true );
var searchOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-search-back.jp2", true );
//var trapOverlay = Image.fetchImageResource( "dungeonquest/templates/dq-trap-back.jp2", true );
var treasureBack = Image.fetchImageResource( "dungeonquest/templates/dq-treasure-back.jp2", true );

function create( diy ) {
	diy.cardVersion = 1;
	diy.extensionName = "Dungeonquest3.seext";
	diy.faceStyle = FaceStyle.TWO_FACES;
	diy.frontTemplateKey = "dungeonquest-treasure-front-sheet";
	diy.backTemplateKey = "dungeonquest-treasure-back-sheet";
	diy.portraitKey = "dungeonquest-treasure";

	diy.name = "<+ H>ammer of <+ U>gly";
	diy.comment = "Here we go again...";
	$SpecialText = "";
	$Back = "Treasure";	 
	$Type = "Loot";              
	$Value = "2,000";			

}

function createInterface( diy, editor ) {
	var panel = new Grid( "fillx" );
	var bindings = new Bindings( editor, diy );
	
	var nameField = textField();
	diy.setNameField( nameField );	
	
	var backCombo = comboBox( [	
		"Catacomb",
		"Corpse",		
		"Crypt",
//		"Door",
		"Dungeon",
		"Search",
//		"Trap",
		"Treasure"
	] );	
	
	var typeCombo = comboBox( [	
		"Event",
		"Loot",	
		"Monster",	
		"Threat",
		"Trap"
	] );
	
	var valueCombo = autocompletionField( [	
		"0",
		"1",		
		"10",
		"100",
		"1,000"
	] );	
	
	var specialTextArea = textArea( "", 12, 15, true );
	
	var credits = new swing.JLabel( "*Random thanks!" );
	credits.enabled = false;		
	
	panel.place(
		"Title", "split", nameField, "growx, wrap",	
		"Back", "split", backCombo, "width pref+20lp, wrap",
//		"Type", "split", typeCombo, "width pref+20lp, wrap",			
		"Value", "split", valueCombo, "width pref+20lp, wrap",	
		"Special Text:", "wrap",
		specialTextArea, "span, gap i, growx, wrap",		
		" ", "wrap",
		credits, "wrap"
	);
	panel.setTitle( "Content" );
	
	bindings.add( "SpecialText", specialTextArea, [0] );
	bindings.add( "Back", backCombo, [1] );	
	bindings.add( "Type", typeCombo, [0] );	
	bindings.add( "Value", valueCombo, [0] );		
	
	panel.addToEditor( editor, "Content", null, null, 0 );
	bindings.bind();
}

var titleBox, specialTextBox, typeBox, valueBox;

function createFrontPainter( comp, sheet ) {
	titleBox = createTitleBox( sheet, true, 8 );
	titleBox.lineTightness = 0.6;	
	specialTextBox = createTitleBox( sheet, false, 8 );	
	specialTextBox.lineTightness = 0.6;
	specialTextBox.alignment = specialTextBox.LAYOUT_TOP|specialTextBox.LAYOUT_CENTER;
	typeBox = createTitleBox( sheet, false, 7 );	
	valueBox = createNumberBox( sheet );
    valueBox.defaultStyle.add( SIZE, 25 );
	valuesmallBox = createNumberBox( sheet );
    valuesmallBox.defaultStyle.add( SIZE, 15 );		

}

function paintFront( g, diy, sheet ) {
	try {
		var settings = diy.settings;
		
		sheet.paintPortrait( g );

		g.setPaint( Color.BLACK );	

		if( $Value != "0" ) {
			if( $SpecialText != "" ) {
			g.drawImage( treasurespecialFront, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-treasure-text-small") );
			valuesmallBox.markupText = $Value;
			valuesmallBox.draw( g, settings.getRegion("dungeonquest-treasure-value-small") );	   
			} else {
			g.drawImage( treasureFront, 0, 0, null );
			valueBox.markupText = $Value;
			valueBox.draw( g, settings.getRegion("dungeonquest-treasure-value") );	
			}    
        } else {
			g.drawImage( treasuretextFront, 0, 0, null );	 
			specialTextBox.markupText = MACROS + $SpecialText;
			specialTextBox.draw( g, settings.getRegion("dungeonquest-treasure-text") );
		}	
		
//		sheet.paintTemplateImage( g );

//		titleBox.markupText = "<b>" + diy.name + "</b>";
		titleBox.markupText = MACROS + diy.name.toUpperCase();
		titleBox.draw( g, settings.getRegion("dungeonquest-treasure-title") );
		
		typeBox.markupText = "<i>" + $Type + "</i>";
		typeBox.draw( g, settings.getRegion("dungeonquest-treasure-type") );
		
//		specialTextBox.markupText = MACROS + $SpecialText;
//		specialTextBox.draw( g, settings.getRegion("dungeonquest-treasure-text") );			
				
	} catch( ex ) { error.handleUncaught( ex ); }
}

function createBackPainter( comp, sheet ) {
}
function paintBack( g, diy, sheet ) {	

		try {
		var settings = diy.settings;
		
		if( $Back == "Catacomb" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 
        }
		else if( $Back == "Corpse" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( corpseOverlay, 31, 97, null ); 	
        }        
        else if( $Back == "Crypt" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( cryptOverlay, 31, 97, null ); 		  	
        }
//		else if( $Back == "Door" ) {
//	    g.drawImage( catacombBack, 0, 0, null ); 		
//	    g.drawImage( doorOverlay, 31, 97, null ); 	
//        }    
		else if( $Back == "Dungeon" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( dungeonOverlay, 31, 97, null ); 	
        }        
        else if( $Back== "Search" ) {
	    g.drawImage( catacombBack, 0, 0, null ); 		
	    g.drawImage( searchOverlay, 31, 97, null ); 		  	
        } 
//		else if( $Back == "Trap" ) {
//	    g.drawImage( catacombBack, 0, 0, null ); 		
//	    g.drawImage( trapOverlay, 31, 97, null ); 	
//        }     
        else if( $Back== "Treasure" ) {
	    g.drawImage( treasureBack, 0, 0, null );		
        } 	
   
	    } catch( ex ) { error.handleUncaught( ex ); }
}

function onClear( diy ) {
	$SpecialText = "";
}

function onRead() {}
function onWrite() {}

// testDIYScript();