uselibrary( "extension" );
uselibrary( "fontutils" );

function getName() {
    return "DungeonQuest Components - Third Edition (FFG)";
}

function getDescription() {
    return "Create cards for FFG's DungeonQuest board game";
}

function getVersion() {
    return 1;
}

function versionWarning() {
	alert( "This plug-in requires a newer version of Strange Eons.", true );
	exit();
}

try {
	
	var sign = PluginContext.compareMicroversions(
		"358:500M",
		PluginContext.microversion
	);
	
	if( sign < 0 ) {
		versionWarning();
	}
} catch( ex ) {

	versionWarning();	
}

offerToHideArkhamHorror();

var bodyFamily = registerFontFamilyFromResources(
	"dungeonquest/fonts/arnopro-regular.ttf",
	"dungeonquest/fonts/arnopro-bold.ttf",
	"dungeonquest/fonts/arnopro-italic.ttf"	
);	

debug( "DungeonQuest - 3rd Edition: registered body family: " + bodyFamily + "\n" );

var titleFamily = registerFontFamilyFromResources(
	"dungeonquest/fonts/nobility.ttf"	
);

debug( "DungeonQuest - 3rd Edition: registered title family: " + titleFamily + "\n" );

var numberFamily = registerFontFamilyFromResources(
	"dungeonquest/fonts/boert.ttf"	
);

debug( "DungeonQuest - 3rd Edition: registered number family: " + numberFamily + "\n" );

Patch.temporary( "dungeonquest-body", bodyFamily );
Patch.temporary( "dungeonquest-title", titleFamily );
Patch.temporary( "dungeonquest-number", numberFamily );

$dungeonquest_body = bodyFamily;
$dungeonquest_title = titleFamily;
$dungeonquest_number = numberFamily;

debug( "DungeonQuest - 3rd Edition: adding class map" );
GameData.parseEditors( "dungeonquest/class-map.txt" );
